package com.example.catchTheLetters.entity;

import cn.hutool.core.collection.ConcurrentHashSet;
import com.example.catchTheLetters.enums.RoomStatus;
import com.example.catchTheLetters.model.vo.Letter;
import lombok.Data;
import org.springframework.web.socket.WebSocketSession;

import java.util.*;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentSkipListMap;

/**
 * 游戏房间
 *
 * @author spyn
 */
@Data
public class GameRoom {
    private final Map<WebSocketSession, PlayerInGame> players = new ConcurrentHashMap<>();
    private final Set<WebSocketSession> readyPlayers = new ConcurrentHashSet<>();
    private RoomStatus status = RoomStatus.WAITING;
    private long roomId;
    private WebSocketSession host;
    // 单词 : 目前在拼这个单词的玩家数
    private final Map<String, Integer> words = new ConcurrentSkipListMap<>();
    // 字母id : 字母
    private final Map<Long, Letter> letters = new ConcurrentHashMap<>();

    public GameRoom(WebSocketSession host, PlayerInGame player) {
        this.roomId = UUID.randomUUID().getLeastSignificantBits();
        this.host = host;
        players.put(host, player);
    }
}
