package com.example.catchTheLetters.entity;

import lombok.Data;

import java.io.Serializable;

/**
 * 游戏中的玩家
 *
 * @author spyn
 */
@Data
public class PlayerInGame implements Serializable {
    private String userId;
    private User user;
    private int score;
    private int health;
    private String currentWord;
    private String currentAnswer;
    private long dropTime;

    public PlayerInGame(String userId, User user) {
        this.userId = userId;
        this.user = user;
        this.score = 0;
        this.health = 100;
        this.currentWord = "";
        this.currentAnswer = "";
    }

    public void addScore(int score) {
        this.score += score;
    }

    public void reduceHealth(int health) {
        this.health = Math.max(0, this.health - health);
    }

    public void setCurrentAnswer(String letter) {
        this.currentAnswer += letter;
    }

    public void clearCurrentAnswer() {
        this.currentAnswer = "";
    }
}
