package com.example.catchTheLetters;

import com.example.catchTheLetters.entity.GameMessage;
import com.example.catchTheLetters.entity.PlayerInput;
import com.example.catchTheLetters.enums.InputKeyType;
import com.example.catchTheLetters.enums.InputState;
import com.example.catchTheLetters.enums.MessageType;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

@SpringBootTest
class JSONTest {
    private final ObjectMapper objectMapper = new ObjectMapper();

    @Test
    void enumToJSON() throws JsonProcessingException {
        var input = new PlayerInput(InputKeyType.LEFT, InputState.PRESS);
        System.out.println(objectMapper.writeValueAsString(new GameMessage<>(MessageType.INPUT, input)));
    }

    @Test
    void jsonToEnum() throws JsonProcessingException {
        var json = "{\"type\":\"INPUT\",\"data\":{\"key\":\"LEFT\",\"state\":\"PRESS\"}}";
        var message = objectMapper.readValue(json, GameMessage.class);
        System.out.println(message);
        System.out.println(message.getType() == MessageType.INPUT);
        System.out.println(message.getData());
    }
}
